/*
Esercizio3
	un programmino di esempio sull'uso dei socket (in modalita` TCP e
	UDP) e le configurazioni client/server in C

config.h
	ho raccolto qui tutto quello che puo` essere modificato in questo
	programma, happy hacking! ;)

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/

//		definizioni

// se qualcuno fa il furbo...
#if ( defined (TCP) && defined (UDP) )
#undef UDP
#endif

// un default per sicurezza
#if ( !defined (TCP) && !defined (UDP) )
#define TCP
#endif

// porta di default
#ifndef PORT
#define PORT	13121	// buon compleano Anna! ;)
#endif			// 13/12/74, 1 sta per un anno dopo di me ;)

// numero di connessioni TCP contemporanee
#ifndef MAXCONN
#define MAXCONN	10
#endif

// numero massimo di errori fork consecutivi
#ifndef MAXFEN
#define MAXFEN	10
#endif

// timeout
#ifndef TOUT
#define TOUT	10
#endif

// numero massimo di timeout prima di abortire
#ifndef MAXTOUT
#define	MAXTOUT	5
#endif

// lunghezza di default dei comandi
#ifndef CLEN
#define CLEN	12
#endif

// lunghezza del buffer di I/O
#ifndef BUFLMAX
#define BUFLMAX	512
#endif

// delay tra una scrittura e l'altra, per fermare il mostro UDP
// sono usec (microsecondi)
#ifndef DELAY
#define DELAY	500
#endif

// qualche definizione per i codici di errore...
#define	CDERR	1	// create/destroy
#define OCERR	2	// open/close
#define RWERR	3	// read/write
#define	FWERR	4	// fork/wait
#define SERR	5	// sting error
#define	OERR	9	// tutto il resto

// mi piacciono... ;)))
#define STDIN	0
#define STDOUT	1
#define STDERR	2


//		funzioni definite nei vari files

extern	void server_net(int sd);
extern	void help (void);
extern	int docmd(int cmdn);
