#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include "config.h"
#include "parser.h"

/*
Esercizio3
	un programmino di esempio sull'uso dei socket (in modalita` TCP e
	UDP) e le configurazioni client/server in C

server.c
	collezione di funzioni per i reali server.

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/



// stampa un po' di help se il parser dice che il comando non e` buono
void help(void) {

int i;

#ifdef TCP
printf ("server_tcp comes with ABSOLUTELY NO WARRANTY;\n");
#endif
#ifdef UDP
printf ("server_udp comes with ABSOLUTELY NO WARRANTY;\n");
#endif
printf ("This is free software, and you are welcome to redistribute it\n");
printf ("under certain conditions; see GNU GPL version 2 or above for detail\n\n");
printf ("mi dispiace, ma il comando non e` valido o perlomeno io\n");
printf ("non sono cosi` stolto fare exec() alla cieca... ;)\n\n");
printf ("i comandi validi sono:\n");

for ( i=1; i <= PCMD; i++ ) {
printf ("\t%s", (char *)cmdname(i));
if ( ((i-1) % 5) == 4 )
	printf("\n");
}
printf("\n");

} // help()



// compie l'azione vera e propria, ovvero fa exec() oppure help()
// a seconda che il comando sia valido o meno
int docmd(int cmdn) {

switch ( cmdn ) {
case	0:	// nessun comando valido:

	help();

	break;

default:	// comando valido!!!

#ifdef DEBUG
	printf ("server(child): execl(%s, %s, NULL);\n",(char *)getcmd(cmdn),(char *)cmdname(cmdn));
#endif
	// eseguo
	execl((char *)getcmd(cmdn),(char *)cmdname(cmdn),NULL);

	// chiaramente, per ogni exec che si rispetti... ;)))
	printf ("server(child): errore eseguendo il comando, probabile path errato\n");
	perror("server(child): errore exec()");
	return(OERR);

} // switch del parser

// se sono qui tutto e` andato a buon fine...
return(0);

} // docmd()
