/*
parser.h
	sono raccolte qui le definizioni del parser

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


//		strutture dati

// numero di comandi, da aumentare se ne aggiungete altrimenti non li caga
// manco di striscio... ;)))
#define PCMD	10

// comandi veri e propri, notare lo static...
static char	*cmds[PCMD] 	=
	{	"ls\0",
		"date\0",
		"ps\0",
		"df\0",
		"du\0",
		"who\0",	// who e` un buco di sicurezza!
		"finger\0",	// idem finger
		"pwd\0",
		"cal\0",
#ifdef DEBUG
		"fake\0",	// inesistente, per tastare errori fork()
#endif
		"free\0"

	};

// path dei comandi, presi da Linux quindi potrebbe esserci il bisogno
// di rivederli...
static char	*cmdpath[PCMD]	=
	{	"/bin/ls\0",
		"/bin/date\0",
		"/bin/ps\0",
		"/bin/df\0",
		"/usr/bin/du\0",
		"/usr/bin/who\0",
		"/usr/local/bin/finger\0",
		"/bin/pwd\0",
		"/usr/bin/cal\0",
#ifdef DEBUG
		"/io/non/esisto\0",
#endif
		"/usr/bin/free\0"

	};


//		funzioni

extern	int	parse (char *c);
extern	char	*getcmd (int i);
extern	char	*cmdname (int i);
